{
  inputs',
  packages',
  pkgs,
}:
pkgs.stdenv.mkDerivation {
  name = "infra-env";
  buildInputs =
    [
      (with pkgs.callPackage (pkgs.path + "/nixos") {configuration = {};};
        with config.system.build; [
          nixos-generate-config
          nixos-install
          nixos-enter
          manual.manpages
        ])
    ]
    ++ (with pkgs; [
      inputs'.colmena.packages.colmena
      nixos-install-tools
      dconf2nix
      inputs'.nixos-anywhere.packages.nixos-anywhere
      nurl

      just
      git-crypt
      vcsh
      gnupg
      git
      ripgrep
      lm_sensors
      pass
      prs
      fuzzel
      wofi
      age
      age-plugin-yubikey
      ssh-to-age
      yubico-piv-tool
      inputs'.sops-nix.packages.default
      sops

      apacheHttpd

      vncdo
      tesseract
      imagemagick

      nmap
      sysstat
      lshw
      xxHash
      linssid
      wavemon
      wirelesstools

      zathura
      xorg.xwininfo
      glxinfo
      autorandr
      arandr
      playerctl
      x11docker
      fwupd

      ntfy

      hedgedoc-cli

      xwayland
    ]);

  # Set Environment Variables
  RUST_BACKTRACE = 1;
}
