{pkgs, ...}: let
  packagedExtensions = with pkgs.vscode-extensions; [
    # bbenoist.Nix
    ms-vscode-remote.remote-ssh

    vscodevim.vim
  ];

  marketPlaceExtensions = pkgs.vscode-utils.extensionsFromVscodeMarketplace [
    # {
    #   name = "vim";
    #   publisher = "vscodevim";
    #   version = "1.17.1";
    #   sha256 = "10f8jz52gr6k2553awa66m006wszj9z2rnshsic6h2aawxiz3zq1";
    # }
    # {
    #   name = "remote-ssh-edit";
    #   publisher = "ms-vscode-remote";
    #   version = "0.56.0";
    #   sha256 = "1gy03ff2xqg7q3y4j47z2l94x5gbw0mjd5h4cl3n0q3iaswk1c1r";
    # }
    {
      name = "Theme-NaturalContrast-With-HC";
      publisher = "74th";
      version = "1.0.0";
      sha256 = "1wxwk059znkflip0c8hyqdfq0h15n4idmff4bnnfdggiqjwhr5rm";
    }
    {
      name = "markdown-toc";
      publisher = "AlanWalk";
      version = "1.5.6";
      sha256 = "0hh38i2dpmrm2akcd4jkxchp6b374m5jzcqm1jqqmkqjmlig7qm5";
    }
    {
      name = "Paper-tmTheme";
      publisher = "DiryoX";
      version = "0.4.0";
      sha256 = "0l8hgbwwg87ysfb22rvwgmkk91i4vjd0kgi30c1bn26bm2pd1gw0";
    }
    {
      name = "Monokai-Polished";
      publisher = "Mit";
      version = "0.3.1";
      sha256 = "11h7sfwp9ikwc8z6bkyxk1678ymfpff8i2p876b208yrq8dy2kr1";
    }
    {
      name = "dot";
      publisher = "Stephanvs";
      version = "0.0.1";
      sha256 = "0rq0wvnbcggg4zb4swxym77knfjma0v9lwf3x45p22qsqx2crvgf";
    }
    {
      name = "rust-snippets";
      publisher = "ZakCodes";
      version = "0.0.1";
      sha256 = "152i23mh8j2l26zpwid3hllxc2abkhr3g939rvxk8bry137vryy2";
    }
    {
      name = "better-comments";
      publisher = "aaron-bond";
      version = "2.1.0";
      sha256 = "0kmmk6bpsdrvbb7dqf0d3annpg41n9g6ljzc1dh0akjzpbchdcwp";
    }
    {
      name = "vscode-icalendar";
      publisher = "af4jm";
      version = "1.0.1";
      sha256 = "0g15f2595ayy9ch4f2ccd8prc51q1mwslilk8sk2ldsmdksaya79";
    }
    {
      name = "hugofy";
      publisher = "akmittal";
      version = "0.1.1";
      sha256 = "02rjwmy7z4qfxws8lgdki53q4b2hjklxn2nlxx3w04kahr759dlg";
    }
    {
      name = "asciidoctor-vscode";
      publisher = "asciidoctor";
      version = "2.8.4";
      sha256 = "0j019vwmd83mbc75kfcqzmpvqzsp3s595cgh6n9978k9q0zjrqad";
    }
    {
      name = "markdown-preview-github-styles";
      publisher = "bierner";
      version = "0.1.6";
      sha256 = "1plj6a1hgbhb740zbw4pbnk7919cx1s6agf5xiiqbb9485x2pqiw";
    }
    {
      name = "made-of-code";
      publisher = "brian-yu";
      version = "0.0.5";
      sha256 = "1cmw63vrpzxv8vkgq674xa2wqqag0a8spr623ngi87925f17p965";
    }
    {
      name = "better-toml";
      publisher = "bungcip";
      version = "0.3.2";
      sha256 = "08lhzhrn6p0xwi0hcyp6lj9bvpfj87vr99klzsiy8ji7621dzql3";
    }
    {
      name = "tabulous";
      publisher = "bwildeman";
      version = "1.2.0";
      sha256 = "0hbp345i19ncvn1v792nr257gmw0nz09nhjniiypnzvz9wszw2j9";
    }
    {
      name = "bracket-pair-colorizer";
      publisher = "CoenraadS";
      version = "1.0.61";
      sha256 = "0r3bfp8kvhf9zpbiil7acx7zain26grk133f0r0syxqgml12i652";
    }
    {
      name = "mustache";
      publisher = "dawhite";
      version = "1.1.1";
      sha256 = "1j8qn5grg8v3n3v66d8c77slwpdr130xzpv06z1wp2bmxhqsck1y";
    }
    {
      name = "vscode-nomnoml";
      publisher = "doctorrustynelson";
      version = "0.3.0";
      sha256 = "07nr6n5ai8m6rap8av47mqi3vv6zchymiqfw8jlbl4hsryszyr43";
    }
    {
      name = "gitlens";
      publisher = "eamodio";
      version = "11.0.5";
      sha256 = "1fi8j5r6cd82a50hv2lwzqnvyvhxf9waamkviyh0wyqi5i1k4q88";
    }
    {
      name = "monokai-light";
      publisher = "ethansugar";
      version = "0.2.1";
      sha256 = "1xn74arpv58hwdywaxvv9xhljl23wsqdpyfrgn9nvd29gsiz71w0";
    }
    {
      name = "Theme-Monokai-Contrast";
      publisher = "gerane";
      version = "0.0.5";
      sha256 = "1m1n1izdjgng0q3yljccwjxj0s60p5nfw3hlw7hb467a1wz479pm";
    }
    {
      name = "Theme-snappy-light";
      publisher = "gerane";
      version = "0.0.5";
      sha256 = "0syrm921l4lka6dmg258c2zi0a758acvcs8y0qm0kjim7h7xxf0w";
    }
    {
      name = "vscode-pull-request-github";
      publisher = "GitHub";
      version = "0.21.3";
      sha256 = "0p03v6y1gh62jby74vkhi897mzj8dg9xb561v0b99x81r9zhwqw0";
    }
    {
      name = "go";
      publisher = "golang";
      version = "0.19.0";
      sha256 = "1xr2c4xn0w68fdcbm8d2wqfb9dxf03w38367ghycrzmz2p4syr98";
    }
    {
      name = "terraform";
      publisher = "hashicorp";
      version = "2.3.0";
      sha256 = "0696q8nr6kb5q08295zvbqwj7lr98z18gz1chf0adgrh476zm6qq";
    }
    {
      name = "bonsai";
      publisher = "hawkeyegold";
      version = "1.4.0";
      sha256 = "0r7bxx1lgbg6p97xwd2wr8j7slz720a1v6vzpd0fhcq83vqzkl89";
    }
    {
      name = "live-html-previewer";
      publisher = "hdg";
      version = "0.3.0";
      sha256 = "0hv5plh44q97355j5la83r8hjsxpv9d173mba34xr4p82a3pcq5p";
    }
    {
      name = "yuml";
      publisher = "JaimeOlivares";
      version = "3.5.1";
      sha256 = "01phwj8kn2zmzpjk97wacnc8iiby0szv40b1030fkcm3szafnya0";
    }
    {
      name = "latex-workshop";
      publisher = "James-Yu";
      version = "8.14.0";
      sha256 = "12bh2gpmak7vgzhjnvk2hw0yqm6wkd7vsm4ki4zbqa6lpriscjyi";
    }
    {
      name = "plantuml";
      publisher = "jebbs";
      version = "2.13.16";
      sha256 = "0672x0a1c9yk0g4vka40f4amgxir2bs25zg6qsims9plj0x2s4si";
    }
    {
      name = "tasks-chooser";
      publisher = "jeremyfa";
      version = "0.3.0";
      sha256 = "0bq80wv7zf94cgn94ll3jj68z35p13r0zw5by62dnlnj1sv7dghi";
    }
    {
      name = "asciidoctor-vscode";
      publisher = "joaompinto";
      version = "2.8.0";
      sha256 = "06nx627fik3c3x4gsq01rj0v59ckd4byvxffwmmigy3q2ljzsp0x";
    }
    {
      name = "contrast-theme";
      publisher = "johndugan";
      version = "1.1.10";
      sha256 = "0hib85318940ajfbzqrpgqh4jr39w18aq6babargbf64yxg94mbw";
    }
    {
      name = "theme-dark-plus-contrast";
      publisher = "k3a";
      version = "0.1.101";
      sha256 = "137kq6i6xn394msjrhj7v6c8shrvw9yf8i01mf4yl4aan2bw3419";
    }
    {
      name = "vscode-gist";
      publisher = "kenhowardpdx";
      version = "3.0.3";
      sha256 = "033iry115hbd5jbdr04frbrcgfpfnsc2z551nlfsaczbg4j9dydw";
    }
    {
      name = "quick-open";
      publisher = "leizongmin";
      version = "1.1.0";
      sha256 = "03avjgkvl2w51f0lvvfksa6lxqb4i9jgz2c74hw686yaydj8mfsp";
    }
    {
      name = "rainbow-csv";
      publisher = "mechatroner";
      version = "1.7.1";
      sha256 = "0w5mijs4ll5qjkpyw7qpn1k40pq8spm0b3q72x150ydbcini5hxw";
    }
    {
      name = "openapi-lint";
      publisher = "mermade";
      version = "1.2.0";
      sha256 = "0q81ifgr211apymbs21y0l3x8n324k6mh7p8kykz2xz38cslyq49";
    }
    {
      name = "swagger-doc-viewer";
      publisher = "mimarec";
      version = "1.0.4";
      sha256 = "1vvqwmfav6c2r1xkyfczm564bi2cpa9nklj35w3h3hrp4f6dnvpx";
    }
    {
      name = "vscode-clang";
      publisher = "mitaki28";
      version = "0.2.3";
      sha256 = "0xbg2frb4dxv7zl43gi25w2mkkh4xq2aidcf5i8b4imys9h720yr";
    }
    {
      name = "prettify-json";
      publisher = "mohsen1";
      version = "0.0.3";
      sha256 = "1spj01dpfggfchwly3iyfm2ak618q2wqd90qx5ndvkj3a7x6rxwn";
    }
    {
      name = "vscode-docker";
      publisher = "ms-azuretools";
      version = "1.8.1";
      sha256 = "08691mwb3kgmk5fnjpw1g3a5i7qwalw1yrv2skm519wh62w6nmw8";
    }
    {
      name = "python";
      publisher = "ms-python";
      version = "2020.11.371526539";
      sha256 = "0iavy4c209k53jkqsbhsvibzjj3fjxa500rv72fywgb2vxsi9fc3";
    }
    {
      name = "jupyter";
      publisher = "ms-toolsai";
      version = "2020.11.372831992";
      sha256 = "0r39xqrbkzcfkz6rca039s87ibx79a983y8lbiglhkmw3bp4p658";
    }
    # fails to download C/C++ tools
    # {
    #   name = "cpptools";
    #   publisher = "ms-vscode";
    #   version = "1.1.2";
    #   sha256 = "09z1vrshvwimdrpsnfs4lyzca2qixp3h85xib8jf2fpxdjl3r5vg";
    # }
    {
      name = "vscode-quick-open-create";
      publisher = "nocksock";
      version = "0.6.0";
      sha256 = "0ipkjm74xpx44h130rmbnkjwsi63kcvq6fr0b0nxqqc9aa9jk22j";
    }
    {
      name = "indent-rainbow";
      publisher = "oderwat";
      version = "7.4.0";
      sha256 = "1xnsdwrcx24vlbpd2igjaqlk3ck5d6jzcfmxaisrgk7sac1aa81p";
    }
    {
      name = "phantypist";
      publisher = "paulofallon";
      version = "1.0.3";
      sha256 = "0rsaklwsd9i25p9j82ivblkbsk5cwjm22afzc2cq5klkbz9vxg62";
    }
    {
      name = "swaggitor";
      publisher = "qnsolutions";
      version = "0.1.1";
      sha256 = "0dhygxawxjhm0q1nmxwwcyhnk4hm1yzadnhc5ha7amdg7gddlrc1";
    }
    {
      name = "vscode-yaml";
      publisher = "redhat";
      version = "0.13.0";
      sha256 = "046kdk73a5xbrwq16ff0l64271c6q6ygjvxaph58z29gyiszfkig";
    }
    {
      name = "papercolor-vscode";
      publisher = "rozbo";
      version = "0.4.0";
      sha256 = "0fla4dfxm6ppqgfvp9rc2izhnv0909yk3r38xmh15ald84i1jhzm";
    }
    {
      name = "iferrblocks";
      publisher = "rstuven";
      version = "1.1.1";
      sha256 = "0ncj1g2dqa1wwqmj27w1356f4b9nlk2narvgyjn208axfwifz1lw";
    }
    {
      name = "rust";
      publisher = "rust-lang";
      version = "0.7.8";
      sha256 = "039ns854v1k4jb9xqknrjkj8lf62nfcpfn0716ancmjc4f0xlzb3";
    }
    {
      name = "bracket-jumper";
      publisher = "sashaweiss";
      version = "1.1.8";
      sha256 = "11sj7h13yjcpd94x07wlmck7cmidk1kla00kjq7wfw2xc1143rqs";
    }
    {
      name = "just";
      publisher = "skellock";
      version = "2.0.0";
      sha256 = "1ph869zl757a11f8iq643f79h8gry7650a9i03mlxyxlqmspzshl";
    }
    {
      name = "line-endings";
      publisher = "steditor";
      version = "1.0.3";
      sha256 = "1mdybbhs771w8r9xqy1n7x2is2vhh6axkssarb2yy7gps3v81ik7";
    }
    {
      name = "code-spell-checker";
      publisher = "streetsidesoftware";
      version = "1.10.0";
      sha256 = "1172wcw1a1mbx8nrlnh1hyizs9abzvqmhwgc6bmp8wvxk8hk4x3i";
    }
    {
      name = "code-spell-checker-german";
      publisher = "streetsidesoftware";
      version = "0.1.8";
      sha256 = "117ba1m427d7nqh2p4djjswbksz1nvy2zkgdnm2iis17gzxscbmz";
    }
    {
      name = "code-spell-checker-german";
      publisher = "streetsidesoftware";
      version = "0.1.8";
      sha256 = "117ba1m427d7nqh2p4djjswbksz1nvy2zkgdnm2iis17gzxscbmz";
    }
    {
      name = "code-spell-checker";
      publisher = "streetsidesoftware";
      version = "1.10.0";
      sha256 = "1172wcw1a1mbx8nrlnh1hyizs9abzvqmhwgc6bmp8wvxk8hk4x3i";
    }
    {
      name = "vscode-open-in-github";
      publisher = "sysoev";
      version = "1.14.0";
      sha256 = "1whyrsckx0gikgjj1812dlsykck7cs696wz9fn4fhcishp9479hp";
    }
    {
      name = "html-preview-vscode";
      publisher = "tht13";
      version = "0.2.5";
      sha256 = "0k75ivigzjfq8y4xwwrgs2iy913plkwp2a68f0i4bkz9kx39wq6v";
    }
    {
      name = "scrolloff";
      publisher = "tickleforce";
      version = "0.0.4";
      sha256 = "1n5xcbcwdj54c9dlscd5igdbga6v9wv5j1qbhjb7p2mf7sbps3cq";
    }
    {
      name = "shellcheck";
      publisher = "timonwong";
      version = "0.12.1";
      sha256 = "0apvbs90mdjk5y6vy2v4azwxhdjqfypqp5d5hh9rlgxyq4m0azz2";
    }
    {
      name = "sort-lines";
      publisher = "Tyriar";
      version = "1.9.0";
      sha256 = "0l4wibsjnlbzbrl1wcj18vnm1q4ygvxmh347jvzziv8f1l790qjl";
    }
    # slow and currently not needed
    # {
    #   name = "vscode-lldb";
    #   publisher = "vadimcn";
    #   version = "1.6.0";
    #   sha256 = "15m0idk75bvbzfxipdxwz2vpdklr15zv92h4mxxpr8db9jjr32vi";
    # }
    # {
    #   name = "vim";
    #   publisher = "vscodevim";
    #   version = "1.17.1";
    #   sha256 = "10f8jz52gr6k2553awa66m006wszj9z2rnshsic6h2aawxiz3zq1";
    # }
    {
      name = "prettify-selected-json";
      publisher = "vthiery";
      version = "1.0.3";
      sha256 = "0g2svrls7x4w75fj6rr839mrwd3sn912vn6ysiy0sasnnc55rpgb";
    }
    {
      name = "debug";
      publisher = "webfreak";
      version = "0.25.0";
      sha256 = "0qm2jgkj17a0ca5z21xbqzfjpi0hzxw4h8y2hm8c4kk2bnw02sh1";
    }
    {
      name = "clang-format";
      publisher = "xaver";
      version = "1.9.0";
      sha256 = "0bwc4lpcjq1x73kwd6kxr674v3rb0d2cjj65g3r69y7gfs8yzl5b";
    }
    {
      name = "vscode-capnp";
      publisher = "xmonader";
      version = "1.0.0";
      sha256 = "0z2shl6qvr3y3m5y63v69x94rzyb2cmf5046afx2yswnll6j52fc";
    }
    {
      name = "plsql-language";
      publisher = "xyz";
      version = "1.8.2";
      sha256 = "16xxa6w03wzd95v1cycmjvw9hfg3chvpclrn28v0qsa3lir1mxrr";
    }
    {
      name = "markdown-pdf";
      publisher = "yzane";
      version = "1.4.4";
      sha256 = "00cjwjwzsv3wx2qy0faqxryirr2hp60yhkrlzsk0avmvb0bm9paf";
    }
    {
      name = "vscode-proto3";
      publisher = "zxh404";
      version = "0.5.2";
      sha256 = "1jmmbz3i0hxq5ka4rsk07mynxh3pkh5g736d9ryv1czhnrb06lwf";
    }
  ];
in {
  programs.vscode = {
    enable = true;
    package = pkgs.vscodium;
    extensions =
      [] ++ packagedExtensions
      #  ++ marketPlaceExtensions
      ;
  };

  home.packages = [pkgs.nixpkgs-fmt pkgs.alejandra];
}
# TODO: automate
# rustup install stable
# rustup component add rust-analysis --toolchain stable
# rustup component add rust-src --toolchain stable
# rustup component add rls --toolchain stable
### original list:
# 74th.Theme-NaturalContrast-With-HC
# AlanWalk.markdown-toc
# DiryoX.Paper-tmTheme
# Mit.Monokai-Polished
# Stephanvs.dot
# ZakCodes.rust-snippets
# aaron-bond.better-comments
# af4jm.vscode-icalendar
# akmittal.hugofy
# asciidoctor.asciidoctor-vscode
# bierner.markdown-preview-github-styles
# brian-yu.made-of-code
# bungcip.better-toml
# bwildeman.tabulous
# CoenraadS.bracket-pair-colorizer
# dawhite.mustache
# doctorrustynelson.vscode-nomnoml
# eamodio.gitlens
# ethansugar.monokai-light
# gerane.Theme-Monokai-Contrast
# gerane.Theme-snappy-light
# GitHub.vscode-pull-request-github
# golang.go
# hashicorp.terraform
# hawkeyegold.bonsai
# hdg.live-html-previewer
# JaimeOlivares.yuml
# James-Yu.latex-workshop
# jebbs.plantuml
# jeremyfa.tasks-chooser
# joaompinto.asciidoctor-vscode
# johndugan.contrast-theme
# k3a.theme-dark-plus-contrast
# kenhowardpdx.vscode-gist
# leizongmin.quick-open
# mechatroner.rainbow-csv
# mermade.openapi-lint
# mimarec.swagger-doc-viewer
# mitaki28.vscode-clang
# mohsen1.prettify-json
# ms-azuretools.vscode-docker
# ms-python.python
# ms-toolsai.jupyter
# ms-vscode.cpptools
# nocksock.vscode-quick-open-create
# oderwat.indent-rainbow
# paulofallon.phantypist
# qnsolutions.swaggitor
# redhat.vscode-yaml
# rozbo.papercolor-vscode
# rstuven.iferrblocks
# rust-lang.rust
# sashaweiss.bracket-jumper
# skellock.just
# steditor.line-endings
# streetsidesoftware.code-spell-checker
# streetsidesoftware.code-spell-checker-german
# sugarpirate.theme-tinacious-contrast
# sysoev.vscode-open-in-github
# tht13.html-preview-vscode
# tickleforce.scrolloff
# timonwong.shellcheck
# Tyriar.sort-lines
# vadimcn.vscode-lldb
# vscodevim.vim
# vthiery.prettify-selected-json
# webfreak.debug
# xaver.clang-format
# xmonader.vscode-capnp
# xyz.plsql-language
# yzane.markdown-pdf
# zxh404.vscode-proto3

