{ lib
, src
, rustPlatform
, libinput
, libxkbcommon
, mesa
, pango
, udev
}:

rustPlatform.buildRustPackage rec {
  pname = "jay";
  version = src.rev;

  inherit src;

  cargoLock.lockFile = "${src}/Cargo.lock";

  buildInputs = [
    libxkbcommon
    mesa
    pango
    udev
    libinput
  ];

  RUSTC_BOOTSTRAP = 1;

  meta = with lib; {
    description = "A Wayland compositor written in Rust";
    homepage = "https://github.com/mahkoh/jay";
    license = licenses.gpl3;
    platforms   = platforms.linux;
    maintainers = with maintainers; [ dit7ya ];
  };
}
