{ lib
, src
, craneLib

, pkg-config
, wayland
, libseat
, libinput
, libxkbcommon
, mesa
, pango
, udev
, dbus
, libGL
}:

craneLib.buildPackage {inherit src;
  pname = "magmawm";
  version = src.rev;

  nativeBuildInputs = [
    pkg-config
  ];

  buildInputs = [
    wayland
    udev
    libxkbcommon
    libinput
    dbus
    libseat
    mesa
  ];

  preFixup = ''
    if [[ -e "$out/bin/magmawm" ]]; then
      patchelf \
        --add-needed "${libGL}/lib/libEGL.so.1" \
        $out/bin/magmawm
    fi
  '';

  meta = with lib; {
    description = "A versatile and customizable Window Manager and Wayland Compositor";
    homepage = "https://github.com/MagmaWM/MagmaWM";
    license = licenses.gpl3;
    platforms   = platforms.linux;
    maintainers = with maintainers; [ ];
  };
}
